
#include "Diction.h"
#include "SVector.h"
#include <stdlib.h>
#define MINLEN 4    //Mindestlaenge zum Vergleichen

Diction::Diction(String _dictionary)
{
  dictionary.open(_dictionary);
  if (!dictionary.good()) cout << "cant find dictionary: " << _dictionary << endl;
  index.open(_dictionary+".index",ios::in,436);
  if (!index.good()) cout << "cant find index: " << _dictionary << ".index" << endl;
}

Diction::~Diction()
{
  dictionary.close();
  index.close();
}
  
bool Diction::isBefore(String word1, String word2)
{
  //is word 1 before word2 [alphabetical order]
  if ((word1.length()<1) || (word2.length()<1)) return false;
  
  return (word1[0] <= word2[0]);
}

int Diction::fits(String word1, String word2)
//word1: actual word
//word2: queried word
//count chars that fit  
{
  int i=0;
  int len=0; 
  
  if (word1.length() <= word2.length())
     	len = word1.length();
  else
     	len = word2.length();
  while((i<len) && (word1[i] == word2[i]))
  {
	  i++;
  }
  return i;
}

DWord Diction::getWord(String _word)
{
  DWord trans;
  String word;
  char tmp[80];
  int pos=0;

  if (_word.length() < 1) 
  {
       trans.setTrans("-|-");
       return trans;
  }
  pos=getIndex(_word);

  _word.upcase();
  dictionary.clear();
  dictionary.seekg(pos, ios::beg);
  do
    {
      tmp[0]='\0';
      dictionary.getline(tmp, 80, '\n');
      word=tmp;
      word.upcase();
    }
  while((word.before("|")!=_word) && (dictionary.good()) && isBefore(word, _word));
  if (word.before("|")==_word) trans.setTrans(tmp);
  return trans;
}

DWord Diction::getNear(String _word)
{
  DWord trans;
  String word;
  char tmp[80];
  int pos = 0;
  int actualfit = 0;
  int mostfit = 0;

  if (_word.length() < 1) 
  {
       trans.setTrans("-|-");
       return trans;
  }
  pos=getIndex(_word);

  _word.upcase();
  dictionary.clear();
  dictionary.seekg(pos, ios::beg);

  do
    {
      tmp[0]='\0';
      dictionary.getline(tmp, 80, '\n');
      word=tmp;
      word=word.before("|");
      word.upcase();
      
      actualfit = fits(word,_word);
      if (actualfit > mostfit) 
      {
	      mostfit = actualfit;
	      trans.setTrans(tmp);
      }
    }
  while(dictionary.good() && isBefore(word, _word) );    
  return trans;
}


SVector *Diction::getNarrow(String _word)
{
  DWord trans;
  SVector *words = new SVector;
  String word;
  char tmp[80];
  int pos=0;
  int len=_word.length();
  int min=MINLEN;
  bool found = false;

  if (_word.length() < 1) 
  {
       trans.setTrans("-|-");
       words->addElement(&trans);
       return words;
  }
  pos=getIndex(_word);

  if (len < min) min=len; // hat Wort ueberhaupt Mindestlaenge ??
  _word.upcase();
  dictionary.clear();
  dictionary.seekg(pos, ios::beg);


  do
    {
      tmp[0]='\0';
      dictionary.getline(tmp, 80, '\n');
      word=tmp;
      word=word.before("|");
      word.upcase();

      if (((int)word.length()) > len)
	{
	  if (word.before(len) == _word) 
	    {
	      trans.setTrans(tmp);
	      words->addElement(&trans);
              found = true;
	    }
	}
      else
	{
	  if (((int)word.length()) >=  min)
	    {
	      if (word == _word.before((int)word.length())) 
		{
		  trans.setTrans(tmp);
		  words->addElement(&trans);
                  found = true;
		}
	    }
	}
    }
  while( (dictionary.good()) && (word[0]<=_word[0]) );    
  if (!found)
  {
	  trans.setTrans("-|-");
	  words->addElement(&trans);
  }
  return words;
}

int Diction::getIndex(String _word)
{
  char tmp[20];
  int ln;

  if (_word.length()<2) _word = _word + "AA";
  _word.upcase();
  ln = (((int)_word[0]-65)*26)+((int)_word[1]-65);
  index.clear();
  index.seekg(0,ios::beg);
  while(ln)
    {
      tmp[0]='\0';
      index.getline(tmp,20,'\n');
      --ln;
    }
  return atoi(tmp+2);
}


